"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Trial = exports.Mode = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));
var _react = _interopRequireDefault(require("react"));
var _Article = _interopRequireDefault(require("./Article"));
var _Heading = require("../Heading/Heading");
var _Text = _interopRequireDefault(require("../Text/Text"));
var _Paragraph = _interopRequireDefault(require("../Paragraph/Paragraph"));
var _Grid = _interopRequireWildcard(require("../Grid/Grid"));
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["children"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _default = {
  title: 'Components/Article/Article',
  component: _Article.default,
  argTypes: {
    mode: {
      control: {
        type: 'select',
        options: {
          undefined: undefined,
          light: 'light',
          dark: 'dark'
        }
      }
    }
  }
};
exports.default = _default;
var Template = function Template(_ref) {
  var children = _ref.children,
    args = (0, _objectWithoutPropertiesLoose2.default)(_ref, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, (0, _extends2.default)({}, args, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Paragraph.default, {
      children: children
    })
  }));
};
var Mode = Template.bind({});
exports.Mode = Mode;
Mode.args = {
  children: 'article',
  mode: 'dark',
  outline: false
};
var Trial = function Trial(args) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_jsxRuntime.Fragment, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Grid.default, {
      cols: 2,
      gutter: [5, 10],
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Heading.H1, {
            children: "Heading one"
          })
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
          mode: "dark",
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Heading.H1, {
            children: "Heading one"
          })
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
          color: "lightgrey",
          children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Grid.default, {
            cols: 2,
            gutter: [10, 10],
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                mode: "dark",
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                outline: true,
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                outline: true,
                mode: "dark",
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            })]
          })
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
          mode: "dark",
          color: "lightgrey",
          children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Grid.default, {
            cols: 2,
            gutter: [10, 10],
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                mode: "light",
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                outline: true,
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Grid.Cell, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Article.default, {
                outline: true,
                mode: "light",
                children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text.default, {
                  children: "Text"
                })
              })
            })]
          })
        })
      })]
    })
  });
};
exports.Trial = Trial;