"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withDocumentationProvider = exports.transformProps = exports.default = exports.TEXT_TRANSFORM = exports.TEXT_DECORATION = exports.MODES = exports.FONT_WEIGHT = exports.DocumentationProvider = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Mode = _interopRequireDefault(require("../context/Mode"));
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["children", "mode"],
  _excluded2 = ["mode"],
  _excluded3 = ["deprecated", "elementType", "children", "fontWeight", "fullScreen", "fullWidth", "fullHeight", "mode", "textDecoration", "textTransform", "className"],
  _excluded4 = ["children", "elementType"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var MODES = {
  LIGHT: 'light',
  DARK: 'dark'
};
exports.MODES = MODES;
var TEXT_TRANSFORM = {
  CAPITALIZE: 'capitalize',
  UPPERCASE: 'uppercase',
  LOWERCASE: 'lowercase'
};
exports.TEXT_TRANSFORM = TEXT_TRANSFORM;
var FONT_WEIGHT = {
  THIN: 'thin',
  LIGHTER: 'lighter',
  LIGHT: 'light',
  REGULAR: 'regular',
  MEDIUM: 'medium',
  SEMIBOLD: 'semi-bold',
  BOLD: 'bold',
  BLACK: 'black'
};
exports.FONT_WEIGHT = FONT_WEIGHT;
var TEXT_DECORATION = {
  UNDERSCORE: 'underscore',
  OVERSCORE: 'overscore',
  UNDERLINE: 'underline',
  OVERLINE: 'overline',
  LINETHROUGH: 'line-through'
};
exports.TEXT_DECORATION = TEXT_DECORATION;
var DocumentationProvider = function DocumentationProvider(_ref) {
  var children = _ref.children,
    _ref$mode = _ref.mode,
    mode = _ref$mode === void 0 ? MODES.LIGHT : _ref$mode,
    otherProps = (0, _objectWithoutPropertiesLoose2.default)(_ref, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Mode.default.Provider, {
    value: (0, _extends2.default)({
      mode: mode
    }, otherProps),
    children: _react.Children.map(children, function (child) {
      /*#__PURE__*/(0, _react.cloneElement)(child, {
        mode: mode
      });
      return child;
    })
  });
};
exports.DocumentationProvider = DocumentationProvider;
var withDocumentationProvider = function withDocumentationProvider(Component) {
  var Base = /*#__PURE__*/(0, _react.forwardRef)(function (_temp, forwardedRef) {
    var _ref2 = _temp === void 0 ? {} : _temp,
      mode = _ref2.mode,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(_ref2, _excluded2);
    var contextProps = (0, _react.useContext)(_Mode.default) || {};
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(DocumentationProvider, {
      mode: mode || contextProps.mode,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(Component, (0, _extends2.default)({
        ref: forwardedRef,
        mode: mode || contextProps.mode || MODES.LIGHT
      }, otherProps))
    });
  });
  return Base;
};
exports.withDocumentationProvider = withDocumentationProvider;
var transformProps = function transformProps(_temp2, displayName) {
  var _cx;
  var _ref3 = _temp2 === void 0 ? {} : _temp2,
    deprecated = _ref3.deprecated,
    elementType = _ref3.elementType,
    children = _ref3.children,
    fontWeight = _ref3.fontWeight,
    fullScreen = _ref3.fullScreen,
    fullWidth = _ref3.fullWidth,
    fullHeight = _ref3.fullHeight,
    mode = _ref3.mode,
    textDecoration = _ref3.textDecoration,
    textTransform = _ref3.textTransform,
    className = _ref3.className,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref3, _excluded3);
  var prefix = displayName ? "-" + displayName : '';
  return (0, _extends2.default)({}, props, {
    className: (0, _classnames.default)("sui-studio-doc" + prefix, (_cx = {}, _cx["sui-studio-doc" + prefix + "-tt-" + textTransform] = Object.entries(TEXT_TRANSFORM).flat().includes(textTransform), _cx["sui-studio-doc" + prefix + "-fw-" + fontWeight] = Object.entries(FONT_WEIGHT).flat().includes(fontWeight), _cx["sui-studio-doc" + prefix + "-td-" + textDecoration] = Object.entries(TEXT_DECORATION).flat().includes(textDecoration), _cx["sui-studio-doc" + prefix + "-deprecated"] = deprecated, _cx["sui-studio-doc" + prefix + "-full-screen"] = fullScreen, _cx["sui-studio-doc" + prefix + "-full-width"] = fullWidth, _cx["sui-studio-doc" + prefix + "-full-height"] = fullHeight, _cx["sui-studio-doc" + prefix + "-mode-" + mode] = Object.entries(MODES).flat().includes(mode), _cx), className)
  });
};
exports.transformProps = transformProps;
var BaseCore = /*#__PURE__*/(0, _react.forwardRef)(function (_ref4, forwardedRef) {
  var children = _ref4.children,
    elementType = _ref4.elementType,
    otherProps = (0, _objectWithoutPropertiesLoose2.default)(_ref4, _excluded4);
  var contextProps = (0, _react.useContext)(_Mode.default) || {};
  var ownProps = Object.assign({}, transformProps((0, _extends2.default)({}, contextProps, otherProps)));
  var ownElementType = elementType;
  if ((elementType === null || elementType === undefined || elementType === _react.Fragment) && ownProps.className === transformProps().className) {
    delete ownProps.className;
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_react.Fragment, (0, _extends2.default)({}, ownProps, {
      children: "children"
    }));
  } else if (ownProps.className !== transformProps().className && (elementType === undefined || elementType === null || elementType === _react.Fragment)) {
    ownElementType = 'span';
  }
  return /*#__PURE__*/(0, _react.createElement)(ownElementType, (0, _extends2.default)({}, ownProps, {
    ref: forwardedRef
  }), children);
});
var BaseConditionalProvided = withDocumentationProvider(BaseCore);
BaseConditionalProvided.displayName = 'Base';
BaseConditionalProvided.propTypes = {};
BaseConditionalProvided.defaultProps = {};
var _default = BaseConditionalProvided;
exports.default = _default;