"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ButtonGroup = exports.Button = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Base = _interopRequireDefault(require("../Base.core"));
require("./Button.scss");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["children", "elementType", "outline", "className"],
  _excluded2 = ["className", "children", "elementType", "outline"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * HTML `button` element DOC styled. Triggers an operation on click.
 */
var Button = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, forwardedRef) {
  var children = _ref.children,
    _ref$elementType = _ref.elementType,
    elementType = _ref$elementType === void 0 ? 'button' : _ref$elementType,
    outline = _ref.outline,
    className = _ref.className,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    elementType: elementType,
    className: (0, _classnames.default)('sui-studio-doc-button', {
      'sui-studio-doc-button-outline': outline
    }, className),
    ref: forwardedRef,
    children: children
  }));
});
exports.Button = Button;
Button.displayName = 'Button';
Button.propTypes = {};
Button.defaultProps = {};

/**
 * HTML wrapper to group multiple `button` HTML elements DOC styled.
 */
var ButtonGroup = /*#__PURE__*/(0, _react.forwardRef)(function (_ref2, forwardedRef) {
  var className = _ref2.className,
    children = _ref2.children,
    _ref2$elementType = _ref2.elementType,
    elementType = _ref2$elementType === void 0 ? 'div' : _ref2$elementType,
    outline = _ref2.outline,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref2, _excluded2);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    elementType: elementType,
    className: (0, _classnames.default)('sui-studio-doc-button-group', {
      'sui-studio-doc-button-group-outline': outline
    }, className),
    ref: forwardedRef,
    children: children
  }));
});
exports.ButtonGroup = ButtonGroup;
ButtonGroup.displayName = 'ButtonGroup';
ButtonGroup.propTypes = {};
ButtonGroup.defaultProps = {};
var _default = Button;
exports.default = _default;