"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.BackgroundColorConsumer = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _color = _interopRequireDefault(require("color"));
var _Base = _interopRequireDefault(require("../Base.core"));
var _useMergeRefs = _interopRequireDefault(require("../../hooks/useMergeRefs/useMergeRefs"));
var _useComputedStyle = _interopRequireDefault(require("../../hooks/useComputedStyle/useComputedStyle"));
require("./BackgroundColorConsumer.scss");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["className", "onClick", "onDoubleClick", "children", "elementType"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * Pantone card of the background element color
 */
var BackgroundColorConsumer = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, forwardedRef) {
  var className = _ref.className,
    onClick = _ref.onClick,
    onDoubleClick = _ref.onDoubleClick,
    children = _ref.children,
    _ref$elementType = _ref.elementType,
    elementType = _ref$elementType === void 0 ? 'div' : _ref$elementType,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref, _excluded);
  var currentRef = (0, _react.useRef)();
  var ref = (0, _useMergeRefs.default)(forwardedRef, currentRef);
  var _useState = (0, _react.useState)(),
    color = _useState[0],
    setColor = _useState[1];
  (0, _useComputedStyle.default)(currentRef, 'background-color', function (color) {
    setColor((0, _color.default)(color));
  });
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    className: (0, _classnames.default)('sui-studio-doc', 'sui-studio-doc-get-background', className),
    role: "button",
    ref: ref,
    elementType: elementType,
    children: color !== undefined && children !== undefined ? children({
      color: color
    }) : null
  }));
});
exports.BackgroundColorConsumer = BackgroundColorConsumer;
BackgroundColorConsumer.displayName = 'BackgroundColorConsumer';
BackgroundColorConsumer.defaultProps = {};
var _default = BackgroundColorConsumer;
exports.default = _default;