"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.BootstrapIcon = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactExtraPropTypes = _interopRequireDefault(require("react-extra-prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactIcons = require("react-icons");
var _Base = _interopRequireDefault(require("../Base.core"));
require("./BootstrapIcon.scss");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["className", "icon", "color", "children", "elementType", "fullWidth", "title", "size"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * Bootstrap icon DOC styled
 */
var BootstrapIcon = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, forwardedRef) {
  var className = _ref.className,
    icon = _ref.icon,
    color = _ref.color,
    children = _ref.children,
    _ref$elementType = _ref.elementType,
    elementType = _ref$elementType === void 0 ? 'span' : _ref$elementType,
    _ref$fullWidth = _ref.fullWidth,
    fullWidth = _ref$fullWidth === void 0 ? true : _ref$fullWidth,
    title = _ref.title,
    size = _ref.size,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref, _excluded);
  var _useState = (0, _react.useState)(function () {
      return function () {
        return null;
      };
    }),
    IconElement = _useState[0],
    setIconElement = _useState[1];
  (0, _react.useEffect)(function () {
    if (icon) {
      Promise.resolve().then(function () {
        return _interopRequireWildcard(require('react-icons/bs'));
      }).then(function (module) {
        return module[icon];
      }).then(function (Element) {
        setIconElement(function () {
          return Element || IconElement;
        });
      });
    }
  }, [icon, IconElement]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    elementType: elementType,
    className: (0, _classnames.default)('sui-studio-doc-icon sui-studio-doc-icon-bootstrap', className),
    fullWidth: fullWidth,
    ref: forwardedRef,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactIcons.IconContext.Provider, {
      value: {
        color: color,
        style: {
          verticalAlign: 'middle',
          textAlign: 'center'
        }
      },
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(IconElement, {
        size: size,
        title: title
      })
    })
  }));
});
exports.BootstrapIcon = BootstrapIcon;
BootstrapIcon.displayName = 'BootstrapIcon';
BootstrapIcon.defaultProps = {};
var _default = BootstrapIcon;
exports.default = _default;