"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnorderedList = exports.OrderedList = exports.ListItem = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Base = _interopRequireDefault(require("../Base.core"));
require("./List.scss");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["children", "className", "elementType"],
  _excluded2 = ["children", "className", "elementType"],
  _excluded3 = ["children", "className", "elementType"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * The HTML `ol` element represents an ordered list of items — typically rendered as a numbered list.
 */
var UnorderedList = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, forwardedRef) {
  var children = _ref.children,
    className = _ref.className,
    _ref$elementType = _ref.elementType,
    elementType = _ref$elementType === void 0 ? 'ul' : _ref$elementType,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    elementType: elementType,
    className: (0, _classnames.default)('sui-studio-doc-unordered-list', className),
    ref: forwardedRef,
    children: children
  }));
});
exports.UnorderedList = UnorderedList;
UnorderedList.displayName = 'UnorderedList';
UnorderedList.propTypes = {};
UnorderedList.defaultProps = {};

/**
 * The HTML `ul` element represents an unordered list of items, typically rendered as a bulleted list.
 */
var OrderedList = /*#__PURE__*/(0, _react.forwardRef)(function (_ref2, forwardedRef) {
  var children = _ref2.children,
    className = _ref2.className,
    _ref2$elementType = _ref2.elementType,
    elementType = _ref2$elementType === void 0 ? 'ol' : _ref2$elementType,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref2, _excluded2);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    elementType: elementType,
    className: (0, _classnames.default)('sui-studio-doc-ordered-list', className),
    ref: forwardedRef,
    children: children
  }));
});
exports.OrderedList = OrderedList;
OrderedList.displayName = 'OrderedList';
OrderedList.propTypes = {};
OrderedList.defaultProps = {};

/**
 * The HTML `li` element is used to represent an item in a list.
 */
var ListItem = /*#__PURE__*/(0, _react.forwardRef)(function (_ref3, forwardedRef) {
  var children = _ref3.children,
    className = _ref3.className,
    _ref3$elementType = _ref3.elementType,
    elementType = _ref3$elementType === void 0 ? 'li' : _ref3$elementType,
    props = (0, _objectWithoutPropertiesLoose2.default)(_ref3, _excluded3);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Base.default, (0, _extends2.default)({}, props, {
    elementType: elementType,
    className: (0, _classnames.default)('sui-studio-doc-list-item', className),
    ref: forwardedRef,
    children: children
  }));
});
exports.ListItem = ListItem;
ListItem.displayName = 'ListItem';
ListItem.propTypes = {};
ListItem.defaultProps = {};